"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var typescript_collections_1 = require("typescript-collections");
var uml = require("../uml/index");
var formatter_1 = require("./formatter");
var Formatter = (function (_super) {
    __extends(Formatter, _super);
    function Formatter() {
        _super.call(this);
        this._outputtedNodes = new typescript_collections_1.Set();
    }
    Formatter.prototype.generateClassDiagram = function (umlProgram) {
        var _this = this;
        var yuml = "// {type:class}\n";
        this._outputtedNodes.clear();
        umlProgram.generalizations.forEach(function (value) {
            yuml += _this._formatNode(umlProgram.nodes.getValue(value.toName));
            yuml += "^" + _this._formatNode(umlProgram.nodes.getValue(value.fromName)) + "\n";
            _this._outputtedNodes.add(value.fromName);
            _this._outputtedNodes.add(value.toName);
        });
        umlProgram.nodes.forEach(function (key, value) {
            if (!_this._outputtedNodes.contains(key)) {
                yuml += _this._formatNode(value) + "\n";
            }
        });
        return yuml;
    };
    Formatter.prototype._formatNode = function (node) {
        if (node instanceof uml.Class) {
            return "[" + node.name + "]";
        }
        else if (node instanceof uml.Interface) {
            return "[<<" + node.name + ">>]";
        }
    };
    return Formatter;
}(formatter_1.AbstractFormatter));
exports.Formatter = Formatter;
